<?php
error_reporting(1);
$para = join(' ',$argv);
$para = preg_replace('/^getlrc.php\s*/i','',$para);
$paras = explode(':',$para);
$file = $paras[0];
$name = $paras[1];
$artist = $paras[2];

if (file_exists($file))
{
	parse_lrc($file);
}
else 
{
	$opts = array(
	  'http'=>array(
	    'method'=>"GET",
	    'header'=>"Referer: http://mp3.baidu.com/\r\n"
	  )
	);
	$context = stream_context_create($opts);
	$name = preg_replace('/^\d*\./','',$name);
	$name = iconv('UTF-8','GB2312',$name);
	$artist = iconv('UTF-8','GB2312',$artist);
	$url = "http://mp3.baidu.com/m?f=ms&tn=baidump3lyric&ct=150994944&lf=2&rn=10&word=".urlencode($name." ".$artist)."&lm=-1";
	$s = file_get_contents($url,false,$context);
	$s = mb_convert_encoding($s,'UTF-8','GB2312');
	preg_match('/找到相关结果(\d{1,10})篇/',$s,$ms);
	if ($ms && intval($ms[1])>0)
	{
		
		preg_match('/LRC歌词来自：(http[^<]+)/i',$s,$ms);
		$url = $ms[1];
		$referer = $url;
		$opts = array(
		  'http'=>array(
		    'method'=>"GET",
		    'header'=>"Referer: ".$referer."\r\n".
				"User-Agent:Baiduspider\r\n".
				"Accept:text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n".
				"Accept-Charset:utf-8\r\n".
				"Keep-Alive:115\r\n".
				"Connection:keep-alive\r\n"
		  )
		);
		$context = stream_context_create($opts);
		
		$lrc = file_get_contents($url,false,$context);
		$lrc = mb_convert_encoding($lrc,'UTF-8','GB2312');
		file_put_contents($file,$lrc);
		parse_lrc($file);
	}
	else
		echo "没有找到歌词";
}

function parse_lrc($file)
{
	$lines = file_get_contents($file);
	
	$re = array();
	$re['lines'] = array();
	preg_match_all('/\[([a-z]{2,10})\:([^\]]+)\]/i',$lines,$ms);
	for($i=0;$i<count($ms[0]);$i++)
	{
		$re[$ms[1][$i]] = $ms[2][$i];
	}
	preg_match_all('/(\[(\d{1,2}[\:\.]\d{1,2}[\.\:]\d{1,2})\])+([^\[]+)/',$lines,$ms);
	foreach($ms[0] as $key=>$line)
	{
		$content = trim($ms[3][$key]);
		if (strlen($content) <= 0) $content = '&nbsp;&nbsp;';
		preg_match_all('/\[(\d{1,2}[\:\.]\d{1,2}[\.\:]\d{1,2})\]/',$line,$_ms);
		for($i=0;$i<count($_ms[0]);$i++)
		{
			$time = str_replace(array(':','.'),'|',$_ms[1][$i]);
			$arr = explode('|',$time);
			$time = intval($arr[0])*60000 + intval($arr[1])*1000 + intval($arr[2])*10;
			$re['lines'][] = array('time'=>$time,'content'=>$content);
		}
	}
	usort($re['lines'],'sortline');
	
	
	$html= '';
	if ($re['ti'])  $html.= '<h1 class="lrc"><span>'.$re['ti'].'</span></h1>';
	if ($re['ar'])  $html.= '<h1 class="lrc"><span>'.$re['ar'].'</span></h1>';
	if ($re['al'])  $html.= '<h1 class="lrc"><span>'.$re['al'].'</span></h1>';
	
	for($i=0;$i<count($re['lines']);$i++)
	{
		$html.= '<div class="lrc" id="lrc_';
		$html.= $re['lines'][$i]['time'];
		$html.='"><span>'.$re['lines'][$i]['content'].'</span></div>';
	}
	echo $html;
}
	
function sortline($a,$b)
{
	if ($a['time'] > $b['time'])
		return 1;
	else
		return -1;
}
?>